/*  (c)2000 Franklin Electronic Publishers, Inc. Burlington, NJ.
    All rights reserved. */

#define CICON_CPP 1

#include <assert.h>
#include <malloc.h>
#include "gui.h"

#include "main_fff.h"
    
extern MainWindow *f_MainWindow;


/* ------------------------------------------------------------------------- */
CIcon::CIcon( U16 id, const IMAGE *image )
	: CViewable( id, image->img_width, image->img_height )
{
	v = (struct CvIcon *) malloc( sizeof(struct CvIcon) );
	SetImage(image);
}


/* ------------------------------------------------------------------------- */
CIcon::~CIcon()
{
	free( v );
}


/* ------------------------------------------------------------------------- */
U16
CIcon::AddChild( CViewable *child, S16 x, S16 y )
{
	assert( !"CIcon::AddChild should not be used" );
	return 0; /* Make compiler happy */
}


/* ------------------------------------------------------------------------- */
void
CIcon::SetFont( const FONT *font )
{
	assert( !"CIcon::SetFont should not be used" );
}


/* ------------------------------------------------------------------------- */
void
CIcon::Draw()
{
	CWindow *window = GetWindow();

	if (window && v->m_image) {
		window->DrawImage( GetX(), GetY(), v->m_image,
				   GetForegroundColor(), GetBackgroundColor(),
				   0,0,65535, 65535, IMG_CMB_IOR );
	}
}


/* ------------------------------------------------------------------------- */
void
CIcon::SetImage( const IMAGE *image )
{
	assert( image );
	v->m_image = 0; /* Prevent draw after width-chg but before height chg */
	SetWidth( image->img_width );
	SetHeight( image->img_height );
	v->m_image = image;
}
