/*==============================================================================


       extra.cpp - addon file to main


==============================================================================*/
#include "sys.h"         // eBookMan include files
#include "gui.h"

extern "C"
{
#include "ereader_hostio.h"
#include "evnt_fun.h"
#include "lcd.h"
#include "timer.h"
#include "ereader_hostio.h"
#include "piezo.h"
#include "ebm_object.h"
#include "stdlib.h"
}

#include "main_fff.h"
#include "enter_name_fff.h"

    extern const IMAGE hair2_bmp;
    extern const IMAGE nose2_bmp;
    extern const IMAGE eyes2_bmp;
    extern const IMAGE ears2_bmp;
    extern const IMAGE mouth2_bmp;

    extern const IMAGE hair3_bmp;
    extern const IMAGE nose3_bmp;
    extern const IMAGE eyes3_bmp;
    extern const IMAGE ears3_bmp;
    extern const IMAGE mouth3_bmp;

    extern const IMAGE hair4_bmp;
    extern const IMAGE nose4_bmp;
    extern const IMAGE eyes4_bmp;
    extern const IMAGE ears4_bmp;
    extern const IMAGE mouth4_bmp;

    extern const IMAGE hair5_bmp;
    extern const IMAGE nose5_bmp;
    extern const IMAGE eyes5_bmp;
    extern const IMAGE ears5_bmp;
    extern const IMAGE mouth5_bmp;

    extern const IMAGE hair6_bmp;
    extern const IMAGE nose6_bmp;
    extern const IMAGE eyes6_bmp;
    extern const IMAGE ears6_bmp;
    extern const IMAGE mouth6_bmp;

    extern const IMAGE hair7_bmp;
    extern const IMAGE nose7_bmp;
    extern const IMAGE eyes7_bmp;
    extern const IMAGE ears7_bmp;
    extern const IMAGE mouth7_bmp;

    extern const IMAGE hair8_bmp;
    extern const IMAGE nose8_bmp;
    extern const IMAGE eyes8_bmp;
    extern const IMAGE ears8_bmp;
    extern const IMAGE mouth8_bmp;

    extern const IMAGE hair9_bmp;
    extern const IMAGE nose9_bmp;
    extern const IMAGE eyes9_bmp;
    extern const IMAGE ears9_bmp;
    extern const IMAGE mouth9_bmp;

    extern const IMAGE hair10_bmp;
    extern const IMAGE nose10_bmp;
    extern const IMAGE eyes10_bmp;
    extern const IMAGE ears10_bmp;
    extern const IMAGE mouth10_bmp;

#define MAX_PARTS 10

const IMAGE Hair_bmp[MAX_PARTS]= {hair1_bmp,hair2_bmp,hair3_bmp,hair4_bmp,hair5_bmp,
hair6_bmp,hair7_bmp,hair8_bmp,hair9_bmp,hair10_bmp};
const IMAGE Ears_bmp[MAX_PARTS]= {ears1_bmp,ears2_bmp,ears3_bmp,ears4_bmp,ears5_bmp,
ears6_bmp,ears7_bmp,ears8_bmp,ears9_bmp,ears10_bmp};
const IMAGE Eyes_bmp[MAX_PARTS]= {eyes1_bmp,eyes2_bmp,eyes3_bmp,eyes4_bmp,eyes5_bmp,
eyes6_bmp,eyes7_bmp,eyes8_bmp,eyes9_bmp,eyes10_bmp};
const IMAGE Nose_bmp[MAX_PARTS]= {nose1_bmp,nose2_bmp,nose3_bmp,nose4_bmp,nose5_bmp,
nose6_bmp,nose7_bmp,nose8_bmp,nose9_bmp,nose10_bmp};
const IMAGE Mouth_bmp[MAX_PARTS]= {mouth1_bmp,mouth2_bmp,mouth3_bmp,mouth4_bmp,mouth5_bmp,
mouth6_bmp,mouth7_bmp,mouth8_bmp,mouth9_bmp,mouth10_bmp};


U16 Hair_cnt, Ears_cnt, Eyes_cnt, Nose_cnt, Mouth_cnt;
U16 Hair_rnd, Ears_rnd, Eyes_rnd, Nose_rnd, Mouth_rnd;

char *Help_text = "Silly Face is a game where you click on the buttons to create silly faces.
A timed game can also be played to reconstruct a silly face.
********************
WhitWareInc Software [whitwareinc@yahoo.com]
Version 2.0
"__DATE__"-"__TIME__"
";

#define MAX_TIMER_SPEED 1000
#define RND_TIMER	500

enum {
	MSG_GAME_LOOP=MSG_USER+1,
};

MainWindow *f_MainWindow;
EnterNameWindow *f_EnterNameWindow;

U8 Running, Reset_face;
U16 Game_score=0;


char Title_bar[50]="";
char Score_str[50]="";

typedef struct score_struct {U16 score; char name[50];};


void MainWindow::HighScore (U16 score)
{
	struct score_struct *high_scores, tmp_score;
	size_t max_size=ebo_roundup(sizeof(score_struct)*10);

	static const ebo_name_t file_name = { "","WhitWare","Sillyface","ini" };
	char *file_ptr=(char *)ebo_roundup(OS_availaddr);
	OS_availaddr=(U32)file_ptr + max_size;

	U16 num_scores, i, j;
	char high_scores_str[500], *name_p;
	
	if (ebo_mapin(&file_name,0,file_ptr,&max_size,1) < 0)
	{
		if ( ebo_new(&file_name,max_size,1) < 0)
      			return;
		else if (ebo_mapin(&file_name,0,file_ptr,&max_size,1) < 0)
			return;
	}
	high_scores = (score_struct *)file_ptr;
	num_scores = 0;
	high_scores_str[0] = 0;
	while ( high_scores[num_scores].score )
	{
		num_scores++;
	}

	if(score)
	{
		if(num_scores > 9)
			num_scores = 9;
		high_scores[num_scores].score = score;
		name_p = f_EnterNameWindow->EnterName->GetText();
		strcpy(high_scores[num_scores].name, name_p);
		free(name_p);
		SetFocus(f_MainWindow);
		num_scores++;
	}
	// qsort(high_scores, (size_t)num_scores, (size_t)sizeof(score_struct), (int (*)(...))ScoreCmp);
	for (i = 0; i < num_scores; i++)
	{
		for (j = i+1; j < num_scores; j++)
			if(high_scores[j].score < high_scores[i].score)
			{
				tmp_score = high_scores[i];
				high_scores[i] = high_scores[j];
				high_scores[j] = tmp_score;
			}
	}		
	sprintf(&high_scores_str[strlen(high_scores_str)],"*************\n  High Scores\n*************\n");
	for (i = 0; i < num_scores; i++)
	{
		sprintf(&high_scores_str[strlen(high_scores_str)],"%6d | %s\n",
			high_scores[i].score, high_scores[i].name);
	}

	GUI_Alert(ALERT_INFO, high_scores_str);

	ebo_unmap(file_ptr, max_size);
}


void MainWindow::NewGame ()
{
	Hair_cnt = Hair_rnd = (rand() % 100) / 10;
	Ears_cnt = Ears_rnd = (rand() % 100) / 10;
	Eyes_cnt = Eyes_rnd = (rand() % 100) / 10;
	Nose_cnt = Nose_rnd = (rand() % 100) / 10;
	Mouth_cnt = Mouth_rnd = (rand() % 100) / 10;
	Hair->SetTimer(MAX_TIMER_SPEED, FALSE, 0);
	Hair->SetImage(&Hair_bmp[Hair_cnt]);
	Ears->SetImage(&Ears_bmp[Ears_cnt]);
	Eyes->SetImage(&Eyes_bmp[Eyes_cnt]);
	Nose->SetImage(&Nose_bmp[Nose_cnt]);
	Mouth->SetImage(&Mouth_bmp[Mouth_cnt]);
	GUI_NeedUpdate();
 	Running = 1;
 	Reset_face = 1;
}

U8 MainWindow::CheckCollision (void)
{
	return FALSE;
}

void MainWindow::UpdateSpeed(void)
{
}

//------------------------------------------------------------------------------
void EnterNameWindow::Close( void )
{
	f_MainWindow->HighScore(Game_score);

	return CWindow::Close();
}

//------------------------------------------------------------------------------
S32 MainWindow::MsgHandler( MSG_TYPE type, CViewable *from, S32 data )
{
	
 // message handler

	switch ( type )
	{
		case MSG_KEY:
			switch ( data )
			{
				case K_MENU: // process request to show menu
					m_menu1->Show();
					return 1;

				default:
					return 0;
			}
		case MSG_PEN_DOWN:
            		if (Running==1)
	       		{
	       			if(Reset_face)
	       			{
					Hair_cnt = 0;
					Ears_cnt = 0;
					Eyes_cnt = 0;
					Nose_cnt = 0;
					Mouth_cnt = 0;
					Hair->SetImage(&Hair_bmp[Hair_cnt]);
					Ears->SetImage(&Ears_bmp[Ears_cnt]);
					Eyes->SetImage(&Eyes_bmp[Eyes_cnt]);
					Nose->SetImage(&Nose_bmp[Nose_cnt]);
					Mouth->SetImage(&Mouth_bmp[Mouth_cnt]);
					Reset_face = 0;
					GUI_NeedUpdate();
				}
			}
			return 1;
 			
            	case MSG_TIMER:
            		GUI_EventMessage( (MSG_TYPE)(MSG_GAME_LOOP), Hair, 0 );
            		return 1;
            		
            	case MSG_GAME_LOOP:
            		if (Running == 1)
            		{
				Game_score++;
				sprintf(Title_bar,"Time: %d", Game_score);
				SetTitle(Title_bar);
				Hair->SetTimer(MAX_TIMER_SPEED, FALSE, 0);
			}
			else
			{
				Hair->SetTimer(RND_TIMER, FALSE, 0);
			}
			rand();
 			return 1;
		case MSG_BUTTON_SELECT:
		{
       			if(Reset_face)
       			{
				Hair_cnt = 0;
				Ears_cnt = 0;
				Eyes_cnt = 0;
				Nose_cnt = 0;
				Mouth_cnt = 0;
				Hair->SetImage(&Hair_bmp[Hair_cnt]);
				Ears->SetImage(&Ears_bmp[Ears_cnt]);
				Eyes->SetImage(&Eyes_bmp[Eyes_cnt]);
				Nose->SetImage(&Nose_bmp[Nose_cnt]);
				Mouth->SetImage(&Mouth_bmp[Mouth_cnt]);
				Reset_face = 0;
				GUI_NeedUpdate();
			}
			else
			{
				switch( from->GetID() )
				{
					case MainWindow_HairButton:
						if (++Hair_cnt >= MAX_PARTS)
							Hair_cnt = 0;
						Hair->SetImage(&Hair_bmp[Hair_cnt]);
						break;
					case MainWindow_EarsButton:
						if (++Ears_cnt >= MAX_PARTS)
							Ears_cnt = 0;
						Ears->SetImage(&Ears_bmp[Ears_cnt]);
						break;
					case MainWindow_EyesButton:
						if (++Eyes_cnt >= MAX_PARTS)
							Eyes_cnt = 0;
						Eyes->SetImage(&Eyes_bmp[Eyes_cnt]);
						break;
					case MainWindow_NoseButton:
						if (++Nose_cnt >= MAX_PARTS)
							Nose_cnt = 0;
						Nose->SetImage(&Nose_bmp[Nose_cnt]);
						break;
					case MainWindow_MouthButton:
						if (++Mouth_cnt >= MAX_PARTS)
							Mouth_cnt = 0;
						Mouth->SetImage(&Mouth_bmp[Mouth_cnt]);
						break;
					default :
						return 0;
				}
			}
			GUI_NeedUpdate();
			if(Running)
			{
				if ((Hair_cnt == Hair_rnd) && (Ears_cnt == Ears_rnd) && (Eyes_cnt == Eyes_rnd) &&
					(Nose_cnt == Nose_rnd) && (Mouth_cnt == Mouth_rnd))
				{
					Running = 0;
					GUI_UpdateNow();
					GUI_Alert(ALERT_INFO, "Good job!");
					if(Game_score)
					{
						f_EnterNameWindow = new EnterNameWindow();
					}
					else
						HighScore(0);
					return 0;
				}
			}
			GUI_UpdateNow();
 			return (1);
		}


		case MSG_MENU_SELECT: // handle menu selection
		{
			switch ((U16)data)
			{
				case IDM_OPTION1: // New Game
					Game_score = 0;
					SetTitle("Sillyface");
					NewGame();
					break;
				case IDM_OPTION2: // Show answer
					Hair_cnt = Hair_rnd;
					Ears_cnt = Ears_rnd;
					Eyes_cnt = Eyes_rnd;
					Nose_cnt = Nose_rnd;
					Mouth_cnt = Mouth_rnd;
					Hair->SetImage(&Hair_bmp[Hair_cnt]);
					Ears->SetImage(&Ears_bmp[Ears_cnt]);
					Eyes->SetImage(&Eyes_bmp[Eyes_cnt]);
					Nose->SetImage(&Nose_bmp[Nose_cnt]);
					Mouth->SetImage(&Mouth_bmp[Mouth_cnt]);
					GUI_NeedUpdate();
				 	Running = 0;
					break;
				case IDM_OPTION3: // High scores
					HighScore(0);
					break;
				case IDM_OPTION4: // Help
					GUI_TextWindow(1,"Help",Help_text);
					break;
				case IDM_OPTION5: // Handwriting help
					GUI_HandwritingHelp(0);
					break;
				case IDM_OPTION6: // Exit
					GUI_Exit();
					break;

			}
			return 1;
		}

	case MSG_OS_NOTIFY:
		switch ((U16) data)
		{
			case NTFY_POWER_ON:
				return 0;
			case NTFY_FOREGROUND:
				if(Running == 2)
				{
					Running = 1;
				}
				return 1;
			case NTFY_BACKGROUND:
				if(Running)
					Running = 2;
				return 1;
			default:
				return 0;
		}

	default:
		return 0;
	}
				
  return CWindow::MsgHandler(type, from, data);
}
//------------------------------------------------------------------------------
void MainWindow::Initialize(void)
{
// set up menu #1 - with shortcuts
	m_menu1=new CMenu(ID_MENU1,0,32767,0,this);
	m_menu1->SetNumRows(7);
	int row=-1;
	m_menu1->SetRow( ++row,IDM_OPTION1,"New Game",'n' );
	m_menu1->SetRow( ++row,IDM_OPTION2,"Show answer",'a' );
	m_menu1->SetRow( ++row,IDM_OPTION3,"High Scores",'s' );
	m_menu1->SetRow( ++row,IDM_OPTION4,"Help",'h' );
	m_menu1->SetRow( ++row,IDM_OPTION5,"Handwriting Help",'w' );
	m_menu1->SetSeparatorRow(++row);
	m_menu1->SetRow( ++row,IDM_OPTION6,"Exit",'e' );
	
//	m_menuBar=new CMenuBar(ID_MENUBAR,23,this);
//	m_menuBar->AddButton(new CPushButton( ID_MENU1_BUTTON,0,0,"Menu"),m_menu1 );

// do additional setup functions
	EnableOSNotify();
	rand();
	Hair->SetTimer(RND_TIMER, FALSE, 0);

}

//------------------------------------------------------------------------------
MainWindow::~MainWindow(void)
{
	delete m_menu1; // cleanup
}

//------------------------------------------------------------------------------
S32 GUI_main( MSG_TYPE type, CViewable *object, S32 data )
{
	switch (type)
	{
	case MSG_APP_START:
		if (OS_is_present && hostIO_am_I_the_current_task())
			HOSTIO_INLINE_BREAKPOINT();
		f_MainWindow = new MainWindow();
		f_MainWindow->Initialize(); // do additional setup here
		return 1;
	case MSG_APP_STOP: // prog exit & cleanup
		delete f_MainWindow;
		return 1;
	default:
		break;
	}
	return 0;
};
//------------------------------------------------------------------------------


